package de.ipk_gatersleben.ag_pbi.fluxbalance.startsim;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;

import org.AttributeHelper;
import org.graffiti.graph.Graph;
import org.graffiti.graph.GraphElement;
import org.graffiti.graph.Node;

public class Constraints {
	
	public void generateUbLbFiles(Graph graph, String path, String[][] rctNameArray) throws IOException {
		// public void generateUbLbFiles(Graph graph, String path, String[][] rctNameArray) throws PreconditionException {
		
		// 1.Berechnung
		for (GraphElement ge : graph.getGraphElements()) {
			if (ge instanceof Node && FBAHelper.isReaction((Node) ge)) {
				Node n = (Node) ge;
				String name = AttributeHelper.getLabel(n, "");
				//System.out.println("name: "+name);
				
				for (int i = 0; i < rctNameArray[0].length; i++) {
					if (rctNameArray[0][i].equals(name)) {
						
						rctNameArray[1][i] = AttributeHelper.getLabel(1, n, ""); // lb
						//System.out.println("lb: "+rctNameArray[1][i]);
						rctNameArray[2][i] = AttributeHelper.getLabel(2, n, ""); // ub
						//System.out.println("ub: "+rctNameArray[2][i]);
						i = rctNameArray[0].length;
					}
				}
			}
		}
		
		// Einlesen in UB, LB-Datei
		String pathUB = path + "UB.txt";
		String pathLB = path + "LB.txt";
		BufferedWriter fileUB = new BufferedWriter(new FileWriter(pathUB));
		BufferedWriter fileLB = new BufferedWriter(new FileWriter(pathLB));
		for (int j = 0; j < rctNameArray[0].length; j++) {
			
			if(rctNameArray[0][j]==null||rctNameArray[1][j]==null||rctNameArray[2][j]==null)
				continue;
			fileLB.write(rctNameArray[1][j]);
			
			fileLB.newLine();
			fileUB.write(rctNameArray[2][j]);
			
			fileUB.newLine();
		}
		fileLB.close();
		fileUB.close();
	}
	
}
